# Method: runReport

- [HTTP request](https://developers.google.com/analytics/devguides/reporting/data/v1/rest/v1alpha/TopLevel/runReport#body.HTTP_TEMPLATE)
- [Request body](https://developers.google.com/analytics/devguides/reporting/data/v1/rest/v1alpha/TopLevel/runReport#body.request_body)
  - [JSON representation](https://developers.google.com/analytics/devguides/reporting/data/v1/rest/v1alpha/TopLevel/runReport#body.request_body.SCHEMA_REPRESENTATION)
- [Response body](https://developers.google.com/analytics/devguides/reporting/data/v1/rest/v1alpha/TopLevel/runReport#body.response_body)
- [Authorization Scopes](https://developers.google.com/analytics/devguides/reporting/data/v1/rest/v1alpha/TopLevel/runReport#body.aspect)
- [Try it!](https://developers.google.com/analytics/devguides/reporting/data/v1/rest/v1alpha/TopLevel/runReport#try-it)

Returns a customized report of your Google Analytics event data. Reports contain statistics derived from data collected by the Google Analytics tracking code. The data returned from the API is as a table with columns for the requested dimensions and metrics. Metrics are individual measurements of user activity on your property, such as active users or event count. Dimensions break down metrics across some common criteria, such as country or event name.

### HTTP request

`POST https://analyticsdata.googleapis.com/v1alpha:runReport`

The URL uses [gRPC Transcoding](https://github.com/googleapis/googleapis/blob/master/google/api/http.proto) syntax.

### Request body

The request body contains data with the following structure:

| JSON representation ||
|---|---|
| ``` { "entity": { object (`https://developers.google.com/analytics/devguides/reporting/data/v1/rest/v1alpha/Entity`) }, "dimensions": [ { object (`https://developers.google.com/analytics/devguides/reporting/data/v1/rest/v1alpha/Dimension`) } ], "metrics": [ { object (`https://developers.google.com/analytics/devguides/reporting/data/v1/rest/v1alpha/Metric`) } ], "dateRanges": [ { object (`https://developers.google.com/analytics/devguides/reporting/data/v1/rest/v1alpha/DateRange`) } ], "offset": string, "limit": string, "metricAggregations": [ enum (`https://developers.google.com/analytics/devguides/reporting/data/v1/rest/v1alpha/MetricAggregation`) ], "dimensionFilter": { object (`https://developers.google.com/analytics/devguides/reporting/data/v1/rest/v1alpha/FilterExpression`) }, "metricFilter": { object (`https://developers.google.com/analytics/devguides/reporting/data/v1/rest/v1alpha/FilterExpression`) }, "orderBys": [ { object (`https://developers.google.com/analytics/devguides/reporting/data/v1/rest/v1alpha/OrderBy`) } ], "currencyCode": string, "cohortSpec": { object (`https://developers.google.com/analytics/devguides/reporting/data/v1/rest/v1alpha/CohortSpec`) }, "keepEmptyRows": boolean, "returnPropertyQuota": boolean } ``` |

| Fields ||
|---|---|
| `entity` | ``object (`https://developers.google.com/analytics/devguides/reporting/data/v1/rest/v1alpha/Entity`)`` A property whose events are tracked. Within a batch request, this entity should either be unspecified or consistent with the batch-level entity. |
| `dimensions[]` | ``object (`https://developers.google.com/analytics/devguides/reporting/data/v1/rest/v1alpha/Dimension`)`` The dimensions requested and displayed. |
| `metrics[]` | ``object (`https://developers.google.com/analytics/devguides/reporting/data/v1/rest/v1alpha/Metric`)`` The metrics requested and displayed. |
| `dateRanges[]` | ``object (`https://developers.google.com/analytics/devguides/reporting/data/v1/rest/v1alpha/DateRange`)`` Date ranges of data to read. If multiple date ranges are requested, each response row will contain a zero based date range index. If two date ranges overlap, the event data for the overlapping days is included in the response rows for both date ranges. In a cohort request, this `dateRanges` must be unspecified. |
| `offset` | `string (https://developers.google.com/discovery/v1/type-format format)` The row count of the start row. The first row is counted as row 0. |
| `limit` | `string (https://developers.google.com/discovery/v1/type-format format)` The number of rows to return. If the `limit` parameter is unspecified, 10,000 rows are returned. The API returns a maximum of 100,000 rows per request, no matter how many you ask for. |
| `metricAggregations[]` | ``enum (`https://developers.google.com/analytics/devguides/reporting/data/v1/rest/v1alpha/MetricAggregation`)`` Aggregation of metrics. Aggregated metric values will be shown in rows where the dimensionValues are set to "RESERVED_(MetricAggregation)". |
| `dimensionFilter` | ``object (`https://developers.google.com/analytics/devguides/reporting/data/v1/rest/v1alpha/FilterExpression`)`` The filter clause of dimensions. Dimensions must be requested to be used in this filter. Metrics cannot be used in this filter. |
| `metricFilter` | ``object (`https://developers.google.com/analytics/devguides/reporting/data/v1/rest/v1alpha/FilterExpression`)`` The filter clause of metrics. Applied at post aggregation phase, similar to SQL having-clause. Metrics must be requested to be used in this filter. Dimensions cannot be used in this filter. |
| `orderBys[]` | ``object (`https://developers.google.com/analytics/devguides/reporting/data/v1/rest/v1alpha/OrderBy`)`` Specifies how rows are ordered in the response. |
| `currencyCode` | `string` A currency code in ISO4217 format, such as "AED", "USD", "JPY". If the field is empty, the report uses the entity's default currency. |
| `cohortSpec` | ``object (`https://developers.google.com/analytics/devguides/reporting/data/v1/rest/v1alpha/CohortSpec`)`` Cohort group associated with this request. If there is a cohort group in the request the 'cohort' dimension must be present. |
| `keepEmptyRows` | `boolean` If false or unspecified, each row with all metrics equal to 0 will not be returned. If true, these rows will be returned if they are not separately removed by a filter. |
| `returnPropertyQuota` | `boolean` Toggles whether to return the current state of this Analytics Property's quota. Quota is returned in [PropertyQuota](https://developers.google.com/analytics/devguides/reporting/data/v1/rest/v1alpha/TopLevel/runReport#PropertyQuota). |

### Response body

If successful, the response body contains an instance of `https://developers.google.com/analytics/devguides/reporting/data/v1/rest/v1alpha/RunReportResponse`.

### Authorization Scopes

Requires one of the following OAuth scopes:

- `https://www.googleapis.com/auth/analytics.readonly`
- `https://www.googleapis.com/auth/analytics`